
/*
 *  I N T R O O T
 *
 *  Integer Square root  function
 *
 *      by PM 2Ring 
 *      Written May 14 1992
 *      Nov  2 1995 Fixed point scaling
 *
 */

/* #define TEST */

#ifdef TEST
#include <stdio.h>
#endif

typedef unsigned long ULONG;
ULONG intsqrt(ULONG n);

ULONG intsqrt(ULONG n)
{
    ULONG x, len, t;

    /* Find bitlength of n */
    for(t=n, len=0; t; t >>= 1)
        len++;

    n <<= 2;            /* Scale up */

    /* 1st approx. has half the bitlength of n */
    x = (n >> (1+(len>>1))) + 1;

    do  /* Newton's method */
        x = (n/x + x) >> 1;
    while(len >>= 1);

    return x>>1;        /* Scale down */
}

#ifdef TEST

#define TNUM (1<<15)     /* Number of tests */

int main(void)
{
    ULONG a, b, c;
    long i, j;

    for (i=2; i<TNUM; i++)
    {
        for (j=-3; j<=3; j++)
        {
            a = i*i + j;

            b = intsqrt(a);
            c = b * b;

            if (c > a || c + 2*b < a)
                printf("\na %lu : b=root(a) %lu b*b %lu\n", a, b, c);
        }
        if (i % 512 == 0)
            printf(".");
    }

    printf("\n");

    return 0;
}

#endif
